classdef Alpha
    properties (SetAccess = private)
        chars
    end
    properties (Dependent = true)
        num_nucl
    end
    
    methods
        function obj = Alpha(chars)
            obj.chars = chars;
        end
        
        function num_nucl = get.num_nucl(obj)
            num_nucl = length(obj.chars);
        end
        
        function c = idx2char(obj, idx)
            if (idx < 1) || (idx > obj.num_nucl)
                error('Trying to convert an integer to an element of the alphabet which is too small/large')
            end
            c = obj.chars(idx);
        end
        function idx = char2idx(obj, c)
            matches = find(obj.chars == c);
            if length(matches) ~= 1
                %error(['Trying to convert an character to an index which is not member of the alphabet: ' char])
                idx = 1;
            else
                idx = matches(1);
            end
        end        
    end
    
    methods (Static = true)
        function b = is_gap(c)
            [s1, s2] = size(c);
            if ((s1 == 1) && (s2 == 1))
                b = (c == '-');
            else
                fh = @(a) a=='-';
                b = arrayfun(fh, c);
            end
        end
    end

end