classdef SQL    
    methods (Static = true)
        % get connection to SQL DB
        function con = get_connection()
            import('MySQL.MySQLConnection');
            persistent connection;
            if (isempty(connection))
                connection = MySQLConnection('localhost', 'small_subtypes', 'root', 'qx,--vt9');
            end
            con = connection;
        end
        
        % save vector in SQL DB
        function id = save_vector(v, table_name, col_name)
            DB_con = SQL.get_connection(); 
            sql_stat = 'DROP TEMPORARY TABLE IF EXISTS Tmp';
            DB_con.executeSQLStatement(sql_stat);     
            sql_stat = ['CREATE TEMPORARY TABLE Tmp ( ID INT, num INT ) SELECT ID, COUNT(*) AS num FROM ' table_name ' WHERE'];
            is_first = true;                   
            for j=1:length(v)
                if (is_first)
                    is_first = false;
                else
                    sql_stat = [sql_stat ' OR'];
                end
                if (isa(v, 'cell'))
                    x = ['''' char(v(j)) '''']; 
                else
                    x = num2str(v(j));
                end
                sql_stat = [sql_stat ' No=' num2str(j) ' AND ' col_name '=' x];
            end
            sql_stat = [sql_stat ' OR No=' num2str(length(v) + 1) ' AND ' col_name '<=>NULL GROUP BY ID' ];
            DB_con.executeSQLStatement(sql_stat);          
            sql_query = ['SELECT ID FROM Tmp WHERE num=' num2str(length(v) + 1)];
            rs = DB_con.executeSQLQuery(sql_query);                    
            if (rs.next())
                id = rs.getInt('ID');                        
            else
                sql_query = ['SELECT * FROM ' table_name];
                rs = DB_con.executeSQLQuery(sql_query);        
                if (rs.next())
                    sql_query = ['SELECT MAX(ID) FROM ' table_name];
                    rs = DB_con.executeSQLQuery(sql_query);    
                    rs.next();
                    id = rs.getInt('MAX(ID)') + 1;      
                else
                    id = 1;
                end
                for j=1:length(v)
                    if (isa(v, 'cell'))
                        x = ['''' char(v(j)) '''']; 
                    else
                        x = num2str(v(j));
                    end
                    sql_stat = ['INSERT INTO ' table_name ' VALUES (' num2str(id) ', ' num2str(j) ', ' x ')'];
                    DB_con.executeSQLStatement(sql_stat);                                                                
                end
                sql_stat = ['INSERT INTO ' table_name ' VALUES (' num2str(id) ', ' num2str(length(v) + 1) ', NULL)'];                
                DB_con.executeSQLStatement(sql_stat);                                                                
            end
        end
    end    
end

